//---------------------------------------------------------------------------
/*
 * Copyright (c) Allan Petersen, 2003.
 * This is a tutorial for twain scanning example
 *
 * (c) Copyright 2003, Allan Petersen
 * ALL RIGHTS RESERVED
 * Permission to use, copy, modify, and distribute this software for
 * any purpose and without fee is hereby granted, provided that the above
 * copyright notice appear in all copies and that both the copyright notice
 * and this permission notice appear in supporting documentation, and that
 * the name of Allan Petersen not be used in advertising
 * or publicity pertaining to distribution of the software without specific,
 * written prior permission.
 *
 * THE MATERIAL EMBODIED ON THIS SOFTWARE IS PROVIDED TO YOU "AS-IS"
 * AND WITHOUT WARRANTY OF ANY KIND, EXPRESS, IMPLIED OR OTHERWISE,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF MERCHANTABILITY OR
 * FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT SHALL ALLAN
 * PETERSEN BE LIABLE TO YOU OR ANYONE ELSE FOR ANY DIRECT,
 * SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY
 * KIND, OR ANY DAMAGES WHATSOEVER, INCLUDING WITHOUT LIMITATION,
 * LOSS OF PROFIT, LOSS OF USE, SAVINGS OR REVENUE, OR THE CLAIMS OF
 * THIRD PARTIES, WHETHER OR NOT ALLAN PETERSEN HAS BEEN
 * ADVISED OF THE POSSIBILITY OF SUCH LOSS, HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE
 * POSSESSION, USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Contact Allan Petersen at <support@allanpetersen.com> or visit
 * www.allanpetersen.com
 *
 *
 *  The mdi form.
 *  I added a few function like zoom in/out and move of the
 *  bitmap. Very simple features. I never came around to make a save
 *  function, perhaps in the future (or not :-)) (AP)
 *
 */
//---------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "ChildWin.h"
//---------------------------------------------------------------------
#pragma resource "*.dfm"
//---------------------------------------------------------------------
__fastcall TMDIChild::TMDIChild(TComponent *Owner)
	: TForm(Owner)
{
    Pressed = false;
    WHRatio = 0.71;
}
//---------------------------------------------------------------------
void __fastcall TMDIChild::FormClose(TObject *Sender, TCloseAction &Action)
{
	Action = caFree;
}
//---------------------------------------------------------------------
void __fastcall TMDIChild::FormResize(TObject *Sender)
{
    ShapeForeGround->Height = Panel1->Height - 30;
    ShapeForeGround->Width  = ShapeForeGround->Height * WHRatio;

    ShapeForeGround->Top  = 10;
    ShapeForeGround->Left = Panel1->Width * 0.5  - ShapeForeGround->Width * 0.5;

    ShapeBackGround->Top    = ShapeForeGround->Top;
    ShapeBackGround->Left   = ShapeForeGround->Left;
    ShapeBackGround->Width  = ShapeForeGround->Width;
    ShapeBackGround->Height = ShapeForeGround->Height;

    ShapeBackGround->Top += 2;
    ShapeBackGround->Left+= 2;

    Image1->Top    = ShapeForeGround->Top+10;
    Image1->Left   = ShapeForeGround->Left+10;
    Image1->Width  = ShapeForeGround->Width-20;
    Image1->Height = ShapeForeGround->Height-20;
}
//---------------------------------------------------------------------------
void __fastcall TMDIChild::TB_ZoomInClick(TObject *Sender)
{
    ShapeForeGround->Height *= 1.2;
    ShapeForeGround->Width  *= 1.2;

    ShapeForeGround->Top  = 10;
    ShapeForeGround->Left = Panel1->Width * 0.5  - ShapeForeGround->Width * 0.5;
    if (ShapeForeGround->Left < 10) ShapeForeGround->Left = 10;

    ShapeBackGround->Top    = ShapeForeGround->Top;
    ShapeBackGround->Left   = ShapeForeGround->Left;
    ShapeBackGround->Width  = ShapeForeGround->Width;
    ShapeBackGround->Height = ShapeForeGround->Height;

    ShapeBackGround->Top += 2;
    ShapeBackGround->Left+= 2;

    Image1->Top    = ShapeForeGround->Top+10;
    Image1->Left   = ShapeForeGround->Left+10;
    Image1->Width  = ShapeForeGround->Width-20;
    Image1->Height = ShapeForeGround->Height-20;
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::TB_ZoomOutClick(TObject *Sender)
{
    ShapeForeGround->Height *= 0.8;
    ShapeForeGround->Width  *= 0.8;

    ShapeForeGround->Top  = 10;
    ShapeForeGround->Left = Panel1->Width * 0.5  - ShapeForeGround->Width * 0.5;
    if (ShapeForeGround->Left < 10) ShapeForeGround->Left = 10;

    ShapeBackGround->Top    = ShapeForeGround->Top;
    ShapeBackGround->Left   = ShapeForeGround->Left;
    ShapeBackGround->Width  = ShapeForeGround->Width;
    ShapeBackGround->Height = ShapeForeGround->Height;

    ShapeBackGround->Top += 2;
    ShapeBackGround->Left+= 2;

    Image1->Top    = ShapeForeGround->Top+10;
    Image1->Left   = ShapeForeGround->Left+10;
    Image1->Width  = ShapeForeGround->Width-20;
    Image1->Height = ShapeForeGround->Height-20;
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::Image1MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
    if (Shift.Contains (ssLeft) && !Pressed) {
        Pressed = true;
        OldX = X,
        OldY = Y;
        }
    if (!Shift.Contains (ssLeft)) {
        Pressed = false;
        }
    if (Pressed) {
        ScrollBox1->ScrollBy (X-OldX, Y-OldY);
        }


}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::FormShow(TObject *Sender)
{
    FormResize(Sender);
}
//---------------------------------------------------------------------------

